<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Predictores de saltos, IE-0521: Predictores de saltos, Esteban Valverde B47214</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Predictores de saltos, IE-0521
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generado por Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Buscar');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Buscar');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">Predictores de saltos, Esteban Valverde B47214 </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><h2>Descripción</h2>
<p>El presente programa implementa cuatro tipos de predictores de saltos:</p><ul>
<li>Bimodal</li>
<li>Pshare</li>
<li>Gshare</li>
<li>Torneo</li>
</ul>
<p>Para cada predictor se utilizan distintos parámetros, sin embargo, por modularidad para ejecutar la simulación se deberán indicar todos en el orden adecuado, como se describe a continuación, los parámetros que no se requieran simplemente se ignoran.</p>
<h2>Uso</h2>
<p>Para ejecutar el programa, se debe hacer uso del siguiente comando: </p><div class="fragment"><div class="line">$ gunzip -c branch-trace-gcc.trace.gz | ./branch -s 3 -bp 2 -gh 4 -ph 4 -o 1</div></div><!-- fragment --><p> Los parámetros del ejecutable se deben indicar en el orden mostrado, con las banderas indicadas, de lo contrario el programa no funcionará. De utilizarse otro archivo de trazas lo que se debe hacer es cambiar el nombre del archivo mostrado en el comando anterior por el que se desea utilizar.</p>
<p><b>NOTA:</b> Al ejecutar el programa siempre se mostrará en pantalla el resumen de la simulación.</p>
<h2>Parámetros</h2>
<ul>
<li><b>-s:</b> Cantidad de bits para la tabla BTH, $2^s$ es el tamaño de la tabla.</li>
<li><b>-bp:</b> Tipo de predictor por utilizar<ul>
<li>0: Bimodal</li>
<li>1: Gshare</li>
<li>2: Pshare</li>
<li>3: Torneo</li>
</ul>
</li>
<li><b>-gh:</b> Número de bits de historia global.</li>
<li><b>-ph:</b> Número de bits de historia privada.</li>
<li><b>-o:</b> Decisición de almacenar en un archivo de texto los resultados de las predicciones de los primeros 5000 saltos<ul>
<li><b>0:</b> No escribir los resultados</li>
<li><b>1:</b> Escribir los resultados</li>
</ul>
</li>
</ul>
<p>El resultado escrito en un archivo de texto se muestra en la carpeta "output" con el nombre del predictor y extensión _.txt_ .</p>
<h2>Notas adicionales</h2>
<p>Si se desearan hacer cambios adicionales al código y ejecutarlo bajo el nombre de branch se deberá recompilar, bajo el nombre de <em>branch</em> como se muestra a continuación:</p>
<div class="fragment"><div class="line">$ g++ main.cpp src/*.cpp -o branch</div></div><!-- fragment --><p> Con el fin de facilitar el proceso de compilación y pruebas se provee de un makefile que tiene tres comandos:</p><ul>
<li><b>build:</b> Compila los archivos.</li>
<li><b>run:</b> Ejecuta el programa con unos parámetros por defecto.</li>
<li><b>clean:</b> Limpia la carpeta de salida de archivos.</li>
</ul>
<h2>Documentación</h2>
<p>La documentación formal del código se encuentra disponible en el directorio <em>doc</em> en el archivo <em>index.html</em>. Esta se puede consultar con el fin de entender de una mejor manera el código desarrollado. </p>
</div></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generado por &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
